using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;


namespace WinDataGridPaginazioneCS
{
    public partial class Form1 : Form
    {
        //Variabili locali per la gestione della paginazione
        private Int32 PaginaCorrente;
        private DataTable dttDati;
        private Int32 TotalePagine;
        private Int32 RecordAttuale;
        public Form1()
        {
            InitializeComponent();
        }

        private void BtnCarica_Click(object sender, EventArgs e)
        {
            //connessione
            OleDbConnection conDati = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=c:\\Northwind.mdb");

            //oggetto per la query
            OleDbDataAdapter daDati = new OleDbDataAdapter("select * from customers", conDati);
            DataSet dtsDati = new DataSet();


            //Carico il dataset
            daDati.Fill(dtsDati, "customers");

            //Gestione delle agpine
            dttDati = dtsDati.Tables["customers"];
            TotalePagine = dttDati.Rows.Count / Convert.ToInt32(TxtRecordPerPagina.Text);

            if (dttDati.Rows.Count % Convert.ToInt32(TxtRecordPerPagina.Text) > 0)
                TotalePagine = TotalePagine + 1;

            //Imposto le variabile per la paginazione
            PaginaCorrente = 1;
            RecordAttuale = 0;
            //Carico i dati
            CaricaDati();
        }
        /// <summary>
        /// Funzione per il carimento dei dati
        /// </summary>
        private void CaricaDati()
        {
            Int32 RecordInziale;
            Int32 RecordFinale;
            //DataTable temporaneo
            DataTable dttTemp;

            //Record per pagina
            Int32 RecordPerPagina;
            //Totale record
            Int32 TotaleRecord;

            RecordPerPagina = Convert.ToInt32(TxtRecordPerPagina.Text);
            //rilevo il totale dei record
            TotaleRecord = dttDati.Rows.Count;
            //Copio i dati in un dataTable temporaneo
            dttTemp = dttDati.Clone();
            //rilevo il record finale
            if (PaginaCorrente == TotalePagine)
                RecordFinale = TotaleRecord;
            else
                RecordFinale = RecordPerPagina * PaginaCorrente;

            //rilevo il recordo iniziale
            RecordInziale = RecordAttuale;

            //importo (copio) i record che dovr visualizzare dal range composto dal record iniziale al record finale
            for (int conta = RecordInziale; conta < RecordFinale; conta++)
            {
                dttTemp.ImportRow(dttDati.Rows[conta]);
                RecordAttuale = RecordAttuale + 1;

            }

            //carico la griglia e visualizzare la posizione
            DtgDati.DataSource = dttTemp;
            txtPosizione.Text = "Pagina " + PaginaCorrente.ToString() + "/" + TotalePagine.ToString();

        }

        private void BtnSuccessivo_Click(object sender, EventArgs e)
        {
            if (TotalePagine == 0)
            {
                MessageBox.Show("Impostare la dimensione della pagina e verificare i dati");
                return;
            }

            PaginaCorrente += 1;
            if (PaginaCorrente > TotalePagine)
            {
                PaginaCorrente = TotalePagine;
                if (RecordAttuale == dttDati.Rows.Count)
                    return;
            }
            CaricaDati();
        }

        private void btnPrecedente_Click(object sender, EventArgs e)
        {
            PaginaCorrente -= 1;
            if (PaginaCorrente < 1)
            {
                PaginaCorrente = 1;
                return;
            }

            RecordAttuale = Convert.ToInt32(TxtRecordPerPagina.Text) * (PaginaCorrente - 1);
            CaricaDati();
        }

        private void btnPrimo_Click(object sender, EventArgs e)
        {
            PaginaCorrente = 1;
            RecordAttuale = 0;
            CaricaDati();
        }

        private void btnUltimo_Click(object sender, EventArgs e)
        {
            PaginaCorrente = TotalePagine;
            RecordAttuale = dttDati.Rows.Count - 1;
            CaricaDati();
        }
    }
}